// Scan.cpp : implementation file
//

#include "stdafx.h"
#include "fphn_cnv.h"
#include "fphn_cnvdlg.h"
#include "Scan.h"

extern CFphn_cnvDlg* pMainDlg;

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CScan dialog


CScan::CScan(CWnd* pParent /*=NULL*/)
	: CDialog(CScan::IDD, pParent)
{
	//{{AFX_DATA_INIT(CScan)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
}


void CScan::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CScan)
		// NOTE: the ClassWizard will add DDX and DDV calls here
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CScan, CDialog)
	//{{AFX_MSG_MAP(CScan)
	ON_WM_TIMER()
	ON_WM_CLOSE()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CScan message handlers

BOOL CScan::OnInitDialog() 
{
	CDialog::OnInitDialog();
	
	// TODO: Add extra initialization here

	//Initialize device context
	pDC=new CClientDC(this);

	GetDlgItem(IDC_SCAN_CHAR)->GetWindowRect(&rect);
	ScreenToClient(&rect);
	
	//Initialize colors, pens, brushes
	
	clr1=RGB(255,255,255);
	clr2=RGB(255,0,0);
	clr3=RGB(0,0,255);

	pPen1=new CPen(PS_SOLID,1,clr1);
	pBrush1=new CBrush(clr1);

	pPen2=new CPen(PS_SOLID,1,clr2);
	pBrush2=new CBrush(clr2);

	//Initialize font
	strcpy(logfont.lfFaceName,pMainDlg->fn);
	logfont.lfHeight=pMainDlg->ifs;
	logfont.lfWidth=0;
	logfont.lfEscapement=0;
	logfont.lfOrientation=0;
	if (pMainDlg->fst_bold) logfont.lfWeight=FW_BOLD;
	else logfont.lfWeight=FW_NORMAL;
	logfont.lfItalic=pMainDlg->fst_italic;
	logfont.lfUnderline=0;
	logfont.lfStrikeOut=0;
	logfont.lfCharSet=ANSI_CHARSET;
	logfont.lfOutPrecision=OUT_DEFAULT_PRECIS;
	logfont.lfClipPrecision=CLIP_DEFAULT_PRECIS;
	logfont.lfQuality=PROOF_QUALITY;
	logfont.lfPitchAndFamily=VARIABLE_PITCH | FF_ROMAN;

	font.CreateFontIndirect(&logfont);
	oldfont=pDC->SelectObject(&font);
	
	pDC->SetTextColor(clr3);
	
	lymax=lxmax=0;
	
	tim=pMainDlg->ins;
	
	status_of_timer=false;
	m_timer = SetTimer(1,100,NULL);
	
	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}

void CScan::OnTimer(UINT nIDEvent) 
{
	// TODO: Add your message handler code here and/or call default
	CString pat;

	int x,y;
	bool check;
	
	unsigned int jx1,jy1,jx2,jy2;
	unsigned int lx,ly;
	
	if (!status_of_timer)
	{
		status_of_timer=true;

		//Draw white box	
		pDC->SelectObject(pPen1);
		pDC->SelectObject(pBrush1);
	
		pDC->Rectangle(rect.left,rect.top,rect.right,rect.bottom);

		//Draw pattern
		pat.Format("%c",tim);
		
		CSize size;
		size=pDC->GetTextExtent(pat);

		unsigned int ix=rect.right-rect.left+1;
		unsigned int iy=rect.bottom-rect.top+1;
		
		unsigned int ix1=rect.left+(ix-size.cx)/2;
		unsigned int iy1=rect.top+(iy-size.cy)/2;
		
		pDC->TextOut(ix1,iy1,pat);
		
		//Scanning dimensions
		check=false;
		jx1=0;
		for (x=rect.left; x<=rect.right; x++)
		{
			for (y=rect.top; y<=rect.bottom; y++)
			{
				if (pDC->GetPixel(x,y)==clr3) 
				{
					check=true;
					break;
				}
			}

			pDC->SelectObject(pPen2);
			pDC->MoveTo(x,rect.top);
			pDC->LineTo(x,rect.bottom);

			if (check) 
			{
				jx1=x;
				break;
			}
		}
		if (!check) goto cant;
		
		jx2=0;
		check=false;
		for (x=rect.right; x>=rect.left; x--)
		{
			for (y=rect.top; y<=rect.bottom; y++)
			{
				if (pDC->GetPixel(x,y)==clr3) 
				{
					check=true;
					break;
				}
			}

			pDC->SelectObject(pPen2);
			pDC->MoveTo(x,rect.top);
			pDC->LineTo(x,rect.bottom);

			if (check) 
			{
				jx2=x;
				break;
			}
		}
		if (!check) goto cant;
		
		jy1=0;
		check=false;
		for (y=rect.top; y<=rect.bottom; y++)
		{
			for (x=rect.left; x<=rect.right; x++)
			{
				if (pDC->GetPixel(x,y)==clr3) 
				{
					check=true;
					break;
				}
			}
				
			pDC->SelectObject(pPen2);
			pDC->MoveTo(rect.left,y);
			pDC->LineTo(rect.right,y);

			if (check) 
			{
				jy1=y;
				break;
			}
		}
		if (!check) goto cant;

		jy2=0;
		check=false;
		for (y=rect.bottom; y>=rect.top; y--)
		{
			for (x=rect.left; x<=rect.right; x++)
			{
				if (pDC->GetPixel(x,y)==clr3) 
				{
					check=true;
					break;
				}
			}
				
			pDC->SelectObject(pPen2);
			pDC->MoveTo(rect.left,y);
			pDC->LineTo(rect.right,y);

			if (check) 
			{
				jy2=y;
				break;
			}
		}
		if (!check) goto cant;
		
		lx=jx2-jx1+1;
		ly=jy2-jy1+1;

		if (lx>lxmax) lxmax=lx;
		if (ly>lymax) lymax=ly;

cant:
		
		UpdateData(false);

		tim++;
		if (tim>pMainDlg->ine)
		{
			if (lxmax>0) lxmax--;
			if (lymax>0) lymax--;
			pMainDlg->x_max=lxmax;
			pMainDlg->y_max=lymax;
			
			if (m_timer)
			{
				KillTimer(m_timer);
				m_timer = NULL;
			}

			OnOK();
		}

		status_of_timer=false;
	}
	
	CDialog::OnTimer(nIDEvent);
}

void CScan::OnClose() 
{
	// TODO: Add your message handler code here and/or call default

	//Restore standard font
	pDC->SelectObject(oldfont);

	CDialog::OnClose();
}
