//
// Class SCS_C_prj_dirs
//                  
// Copyright (C) 1998 by Grigori G.Fursin
//

//Import libraries...
import java.awt.*;
import java.awt.event.*;

public class SCS_C_prj_dirs extends Dialog implements ActionListener, ItemListener
{
	//Variables
	Dimension size;

	FGGCFG fggcfg=null;
	SCS_C_PRJ prj=null;

	List comp1;
	TextField comp2;
	Button comp3a;
	Button comp3b;
	Button comp3c;

	String str3a="Add";
	String str3b="Change";
	String str3c="Remove";

	Button comp4;
	Button comp5;
	Button comp6;

	String str4="Undo changes";
	String str5="OK";
	String str6="Cancel";

	int DirsMax;

	Frame Parent=null;

	// *******************************************************************
	public SCS_C_prj_dirs(Frame dw, FGGCFG xfggcfg, SCS_C_PRJ xprj)
	{
		super(dw, "Directories on SCS Server", true);

		Parent=dw;

		int gap=10;

		fggcfg=xfggcfg;
		prj=xprj;

		//First panel for border
		Panel p=new Panel();
		FlowLayout lt=new FlowLayout(FlowLayout.LEFT);
		lt.setHgap(gap);
		lt.setVgap(gap);

		setLayout(lt);

		add(p);

		BorderLayout lt0=new BorderLayout();
		lt0.setHgap(gap);
		lt0.setVgap(gap);

		BorderLayout lt1=new BorderLayout();
		lt1.setHgap(gap);
		lt1.setVgap(gap);

		FlowLayout lt1a=new FlowLayout(FlowLayout.CENTER);
		lt1a.setHgap(gap);
		lt1a.setVgap(gap);

		FlowLayout lt2=new FlowLayout(FlowLayout.CENTER);
		lt2.setHgap(gap);
		lt2.setVgap(gap);

		SCS_C_FramedArea p1=new SCS_C_FramedArea();
		p1.setLayout(lt1);

		Panel p1a=new Panel();
		p1a.setLayout(lt1a);

		Panel p2=new Panel();
		p2.setLayout(lt2);

		comp1=new List(8, false);
		comp1.addItemListener(this);
		comp2=new TextField(48);
		comp3a=new Button(str3a);
		comp3a.addActionListener(this);
		comp3b=new Button(str3b);
		comp3b.addActionListener(this);
		comp3c=new Button(str3c);
		comp3c.addActionListener(this);
                
		p1.add("North", comp1);
		p1.add("Center", comp2);
		p1.add("South", p1a);
		p1a.add(comp3a);
		p1a.add(comp3b);
		p1a.add(comp3c);

		comp4=new Button(str4);
		comp4.addActionListener(this);
		comp5=new Button(str5);
		comp5.addActionListener(this);
		comp6=new Button(str6);
		comp6.addActionListener(this);

		p2.add(comp4);
		p2.add(comp5);
		p2.add(comp6);

		p.setLayout(lt0);
		p.add("Center", p1);
		p.add("South", p2);		

		//Positioning
		Point pt=dw.getLocationOnScreen();

		setLocation(pt.x+40, pt.y+40);

		//Packing elements in window
		pack();

		size=getSize();
		
		//Updating parameters
		DirsMax=0;
		if (prj!=null)
		{
			DirsMax=prj.getDirsMax();
		}

		my_update1();

		my_update();

		enableEvents(AWTEvent.WINDOW_EVENT_MASK|
			AWTEvent.COMPONENT_EVENT_MASK);

		show();
	}

	// *******************************************************************
	public void actionPerformed(ActionEvent e) 
	{
		String x;
		int i;

		String command = e.getActionCommand();

		if (command.equals(str3a)) 
		{	        
			x=comp2.getText();
			if (!x.equals("")) 
			{
				i=comp1.getItemCount();
				if (i<DirsMax)
				{
					comp1.add(x);
					my_update();
				}
				else
				{
					MsgBox msgbox=new MsgBox(Parent, 1, "Sorry, but you can't add more items!");

					msgbox=null;
        	
					System.gc();
					System.runFinalization();
				}
			}
		} 
		else if (command.equals(str3b)) 
		{	        
			i=comp1.getSelectedIndex();

			if (i!=-1) 
			{
				x=comp2.getText();
				if (x.equals("")) comp1.delItem(i);
				else comp1.replaceItem(x, i);
			}

			my_update();

		} 
		else if (command.equals(str3c)) 
		{	        
			i=comp1.getSelectedIndex();

			if (i!=-1) comp1.delItem(i);

			my_update();
		} 
		else if (command.equals(str4)) 
		{	        
			my_update1();
		} 
		else if (command.equals(str5))
		{           
			if (prj!=null)
			{
				prj.clearDirs();
			
				i=comp1.getItemCount();
				if (i!=0)
				{
					for (int j=0; j<i; j++) prj.addDirs(comp1.getItem(j));
				}
			}
	
			dispose();
		} 
		else if (command.equals(str6)) 
		{
			dispose();
		} 
	}

	// *******************************************************************
	protected void processEvent(AWTEvent e)
	{
		if (getSize()!=size)
		{
			setSize(size);
		}

		if (e.getID() == Event.WINDOW_DESTROY)
		{
        		dispose();
		}
	}

	// *******************************************************************
	private void my_update()
	{
		if (comp1.getSelectedIndex()!=-1)
		{
			comp3b.setEnabled(true);
			comp3c.setEnabled(true);
		}
		else
		{
			comp3b.setEnabled(false);
			comp3c.setEnabled(false);
		}
	}

	// *******************************************************************
	private void my_update1()
	{
		if (prj!=null)
		{
			int DirsCur=prj.getDirsCur();

			comp1.removeAll();

			if (DirsCur!=0)
			{
				for (int i=0; i<DirsCur; i++)
				{
					comp1.deselect(i);
					comp1.add(prj.getDirs(i));
				}
			}
		}		
	}

	// *******************************************************************
	public void itemStateChanged(ItemEvent e1)
	{
		int i=comp1.getSelectedIndex();

		if (i!=-1) comp2.setText(comp1.getItem(i));			

		my_update();
	}
}
