//
// Class SCS_C_prj_prop
//                  
// Copyright (C) 1998 by Grigori G.Fursin
//

//Import libraries...
import java.awt.*;
import java.awt.event.*;

public class SCS_C_prj_prop extends Dialog implements ActionListener, ItemListener
{
	//Variables
	Dimension size;

	FGGCFG fggcfg=null;
	SCS_C_PRJ prj=null;

	Label comp1a;
	TextField comp1b;
	Label comp2a;
	TextField comp2b;
	Label comp3a;
	TextField comp3b;
	Label comp4a;
	Checkbox comp4b;
	Label comp5a;
	TextField comp5b;
	Label comp6a;
	TextField comp6b;
	Label comp7a;
	TextField comp7b;
	Label comp8a;
	TextField comp8b;

	String s_b1="Undo changes";
	String s_b2="OK";
	String s_b3="Cancel";

	// *******************************************************************
	public SCS_C_prj_prop(Frame dw, FGGCFG xfggcfg, SCS_C_PRJ xprj)
	{
		super(dw, "Project Properties", true);

		int gap=10;

		fggcfg=xfggcfg;
		prj=xprj;

		//First panel for border
		Panel p=new Panel();
		FlowLayout fl=new FlowLayout(FlowLayout.LEFT);
		fl.setHgap(gap);
		fl.setVgap(gap);

		setLayout(fl);

		add(p);

		BorderLayout gl=new BorderLayout();
		gl.setHgap(gap);
		gl.setVgap(gap);

		GridLayout gl1=new GridLayout(8,2);
		gl1.setHgap(gap);
		gl1.setVgap(gap);

		FlowLayout gl2=new FlowLayout(FlowLayout.CENTER);

		SCS_C_FramedArea p1=new SCS_C_FramedArea();
		p1.setLayout(gl1);

		Panel p2=new Panel();
		p2.setLayout(gl2);

		int len=32;
		comp1a=new Label("Main project directory on SCS Server:", Label.LEFT);
		comp1b=new TextField("", len);
		comp2a=new Label("File(s) to compile:", Label.LEFT);
		comp2b=new TextField("", len);
		comp3a=new Label("Name of executable (output) file:", Label.LEFT);
		comp3b=new TextField("", len);
		comp4a=new Label("Connect MPI Library to project:", Label.LEFT);
		comp4b=new Checkbox("", false);
		comp4b.addItemListener(this);
		comp5a=new Label("Number of processors:", Label.LEFT);
		comp5b=new TextField("", len);
		comp6a=new Label("Period for checking status of project:", Label.LEFT);
		comp6b=new TextField("", len);
		comp7a=new Label("ID of 'compile' job:", Label.LEFT);
		comp7b=new TextField("", len);
		comp8a=new Label("ID of 'run' job:", Label.LEFT);
		comp8b=new TextField("", len);

		my_update();

		p1.add(comp1a); 
		p1.add(comp1b);
		p1.add(comp2a); 
		p1.add(comp2b);
		p1.add(comp3a); 
		p1.add(comp3b);
		p1.add(comp4a); 
		p1.add(comp4b);
		p1.add(comp5a); 
		p1.add(comp5b);
		p1.add(comp6a); 
		p1.add(comp6b);
		p1.add(comp7a); 
		p1.add(comp7b);
		p1.add(comp8a); 
		p1.add(comp8b);
                
		Button b1=new Button(s_b1);
		b1.addActionListener(this);
		Button b2=new Button(s_b2);
		b2.addActionListener(this);
		Button b3=new Button(s_b3);
		b3.addActionListener(this);

		p2.add(b1);
		p2.add(b2);
		p2.add(b3);

		p.setLayout(gl);
		p.add("Center", p1);
		p.add("South", p2);		

		//Positioning
		Point pt=dw.getLocationOnScreen();

		setLocation(pt.x+40, pt.y+40);

		//Packing elements in window
		pack();

		size=getSize();
		
		//Updating parameters
		my_update();

		enableEvents(AWTEvent.WINDOW_EVENT_MASK|
			AWTEvent.COMPONENT_EVENT_MASK);

		show();
	}

	// *******************************************************************
	public void actionPerformed(ActionEvent e) 
	{
		String str3, str4;
		String x;

		int dec;

		String command = e.getActionCommand();
		if (command.equals(s_b1)) 
		{	        
			my_update();
		} 
		else if (command.equals(s_b2))
		{           
			prj.setMainDir(comp1b.getText());
			prj.setFilesComp(comp2b.getText());
			prj.setOutFile(comp3b.getText());
			prj.setMPI(comp4b.getState());

                        x=comp5b.getText();
			if (x.equals("")) x="1";
			try {dec=Integer.decode(x).intValue();}
			catch (NumberFormatException nfe1) {dec=1;}
			prj.setMPI_Proc(dec);

                        x=comp6b.getText();
			if (x.equals("")) x="1";
			try {dec=Integer.decode(x).intValue();}
			catch (NumberFormatException nfe2) {dec=1;}
			prj.setPeriod(dec);

			prj.setCompileID(comp7b.getText());
			prj.setRunID(comp8b.getText());

			dispose();
		} 
		else if (command.equals(s_b3)) 
		{
			dispose();
		} 
	}

	// *******************************************************************
	protected void processEvent(AWTEvent e)
	{
		if (getSize()!=size)
		{
			setSize(size);
		}

		if (e.getID() == Event.WINDOW_DESTROY)
		{
        		dispose();
		}
	}

	// *******************************************************************
	public void itemStateChanged(ItemEvent e1)
	{
		check_mpi();
	}

	// *******************************************************************
	private void my_update()
	{
		boolean x;
		String str;

		if (prj!=null)
		{
			comp1b.setText(prj.getMainDir());
			comp2b.setText(prj.getFilesComp());
			comp3b.setText(prj.getOutFile());

			if (prj.getMPI()) x=true; else x=false;
			comp4b.setState(x);

			if (x)
			{
				comp5a.setEnabled(true);
				comp5b.setEnabled(true);
			}
			else
			{
				comp5a.setEnabled(false);
				comp5b.setEnabled(false);
			}

			str=String.valueOf(prj.getMPI_Proc());
			comp5b.setText(str);

			str=String.valueOf(prj.getPeriod());
			comp6b.setText(str);

			comp7b.setText(prj.getCompileID());
			comp8b.setText(prj.getRunID());
		}
	}

	// *******************************************************************
	private void check_mpi()
	{
		if (comp4b.getState())
		{
			comp5a.setEnabled(true);
			comp5b.setEnabled(true);
		}
		else
		{
			comp5a.setEnabled(false);
			comp5b.setEnabled(false);
		}
	}
}
