// RUN.CPP - Implementation file for your Internet Server
//    run Extension

#include "stdafx.h"
#include <afxdb.h>

#include "run.h"
#include "misc1.h"

#include <iostream.h>
#include <fstream.h>
#include <string.h>

#include "FGGCfg.h"
CFGGCfg *fggcfg=NULL;
#include "run_cfg.h"
#define CfgMaxParam 3

#define StrMaxLen 512
#define DirMaxLen 1024

char AppDir[DirMaxLen];

///////////////////////////////////////////////////////////////////////
// The one and only CWinApp object
// NOTE: You may remove this object if you alter your project to no
// longer use MFC in a DLL.

CWinApp theApp;

///////////////////////////////////////////////////////////////////////
// command-parsing map

BEGIN_PARSE_MAP(CRunExtension, CHttpServer)
	// TODO: insert your ON_PARSE_COMMAND() and 
	// ON_PARSE_COMMAND_PARAMS() here to hook up your commands.
	// For example:

	ON_PARSE_COMMAND(Default, CRunExtension, ITS_PSTR ITS_PSTR ITS_PSTR ITS_PSTR ITS_PSTR)
	ON_PARSE_COMMAND_PARAMS("Login Password FullName MPI=No Processors")
	DEFAULT_PARSE_COMMAND(Default, CRunExtension)
END_PARSE_MAP(CRunExtension)


///////////////////////////////////////////////////////////////////////
// The one and only CRunExtension object

CRunExtension theExtension;


///////////////////////////////////////////////////////////////////////
// CRunExtension implementation

CRunExtension::CRunExtension()
{
}

CRunExtension::~CRunExtension()
{
}

BOOL CRunExtension::GetExtensionVersion(HSE_VERSION_INFO* pVer)
{
	// Call default implementation for initialization
	CHttpServer::GetExtensionVersion(pVer);

	// Load description string
	TCHAR sz[HSE_MAX_EXT_DLL_NAME_LEN+1];
	ISAPIVERIFY(::LoadString(AfxGetResourceHandle(),
			IDS_SERVER, sz, HSE_MAX_EXT_DLL_NAME_LEN));
	_tcscpy(pVer->lpszExtensionDesc, sz);
	return TRUE;
}

///////////////////////////////////////////////////////////////////////
// CRunExtension command handlers

void CRunExtension::Default(CHttpServerContext* pCtxt,
								LPCTSTR pstrLogin, 
								LPCTSTR pstrPassword,
								LPCTSTR pstrFullName, 
								LPCTSTR pstrMPI,
								LPCTSTR pstrProcessors)

{
	char str1[StrMaxLen];
	char str1a[StrMaxLen];
	char str1b[StrMaxLen];
	
	char str2[DirMaxLen];
	char str2a[DirMaxLen];
	char str2b[DirMaxLen];
	char str2c[DirMaxLen];
	char str2d[DirMaxLen];

	CDatabase db;
	CRecordset fQuery(&db);
	CDBVariant varValue;

	TCHAR szError[1024];

	unsigned long id_user;
	unsigned long id_run;
	unsigned long processors;

	//Get directory of current application
	GetModuleFileName(AfxGetResourceHandle(),str2,DirMaxLen);
	_splitpath(str2, str2a, str2b, str2c, str2d);
		
	strcpy(AppDir, str2a);
	strcat(AppDir, str2b);
	
	//Get file with HTML header
	strcpy(str2,AppDir);
	strcat(str2,"run.ht1");

	//Creating header of the HTML document
	if (prt_file_t(pCtxt, str2)!=0)
	{
		*pCtxt << _T("<HTML>\n");
		*pCtxt << _T("<B>Internal Error:</B> Can't find file 'run.ht1' [E010]!<BR>\n");
		*pCtxt << _T("</HTML>\n");
		return;
	}
	
	//Loading configuration
	strcpy(str2,AppDir);
	strcat(str2,"run.cfg");

	static CFGGCfg CSCS_CCfg(CfgMaxParam, StrMaxLen, str2);
	fggcfg=&CSCS_CCfg;

	if (CSCS_CCfg.Load()!=0) 
	{
		*pCtxt << _T("<B>Internal Error:</B> Can't find configuration file [E020]!<BR>\n");
		*pCtxt << _T("</HTML>\n");
		return;
	}
	//check_cfg(); Checking configuration, if necessary!

	//Ready to process query!
	
	//Checking that Login is not NULL!
	if (strlen(pstrLogin)==0)
	{
		strcpy(str1a, "<CENTER>\n");
		strcat(str1a, "You must present your <B>LOGIN</B>!<BR>\n");
		strcat(str1a, "</CENTER>\n");
	
		prt_warning(pCtxt, AppDir, "run", str1a);
		return;
	}
	
	//Checking that Password is not NULL!
	if (strlen(pstrPassword)==0)
	{
		strcpy(str1a, "<CENTER>\n");
		strcat(str1a, "You must present your <B>PASSWORD</B>!<BR>\n");
		strcat(str1a, "</CENTER>\n");

		prt_warning(pCtxt, AppDir, "run", str1a);
		return;
	}
		
	//Checking that FullName is not NULL!
	if (strlen(pstrFullName)==0)
	{
		strcpy(str1a, "<CENTER>\n");
		strcat(str1a, "You must input <B>name of file</B> to run!<BR>\n");
		strcat(str1a, "</CENTER>\n");

		prt_warning(pCtxt, AppDir, "run", str1a);
		return;
	}
	
	//Checking that if MPI=Yes, then Processors is not NULL!
	processors=1;
	strcpy(str1a, pstrMPI);
	if (!strcmp(_strupr(str1a),"YES"))
	{
		if (strlen(pstrProcessors)!=0) processors=strtoul(pstrProcessors, NULL, 10);
		
		if (processors > strtoul((fggcfg->Get(3)), NULL, 10))
		{	
			strcpy(str1a, "<CENTER>\n");
			strcat(str1a, " <TT><FONT SIZE=+2>\n");
			strcat(str1a, " You number of processors must not exceed <B>");
			strcat(str1a, fggcfg->Get(3));
			strcat(str1a, "</B>!<BR>\n");
			strcat(str1a, " </FONT></TT>\n");
			strcat(str1a, "</CENTER>\n");
			
			prt_warning(pCtxt, AppDir, "run", str1a);
			return;
		}

		if (processors==0) processors=1;
	}

	//Connecting to database 'Users' through ODBC
	// (Parameter #1 in configuration = 
	//  Registration name of this database in ODBC)!
	strcpy(str1, "DSN=");
	strcat(str1, fggcfg->Get(1));

	try
	{
		//Open database
		if (!db.OpenEx(_TEXT(str1), CDatabase::noOdbcDialog))
		{
			*pCtxt << _T("<B>Internal Error:</B> Can't connect to database 'users' [E030]!<BR>\n");
			*pCtxt << _T("</HTML>\n");
					
			return;
		}
	
		//Looking for login and password
		strcpy(str1, "SELECT Accounts.ID_USER, Accounts.ACTIVE FROM Accounts WHERE (((Accounts.LOGIN)='");
		strcat(str1, pstrLogin);
		strcat(str1, "') AND ((Accounts.PASSWORD)='");
		strcat(str1, pstrPassword);
		strcat(str1, "'))");

		if (!fQuery.Open(AFX_DB_USE_DEFAULT_TYPE, _TEXT(str1)))
		{
			*pCtxt << _T("<B>Internal Error:</B> Can't open record set of database 'users' [E040]!<BR>\n");
			*pCtxt << _T("</HTML>\n");
					
			db.Close();

			return;
		}

		// Create a CDBVariant object to
		// store field data
		if (fQuery.IsEOF())
		{
			strcpy(str1a, "<CENTER>\n");
			strcat(str1a, " <B><TT><FONT SIZE=+2>\n");
			strcat(str1a, "  User was not found!<BR>\n");
			strcat(str1a, " </FONT></TT></B>\n");
			strcat(str1a, " <BR><BR>\n");
			strcat(str1a, " Please, check <B>Login</B> and <B>Password</B>!\n");
			strcat(str1a, "</CENTER>\n");
			
			prt_warning(pCtxt, AppDir, "run", str1a);
			
			fQuery.Close();
			db.Close();
			
			return;
		}

		//ID_USER
		fQuery.GetFieldValue((short) 0, varValue);
			
		// How to work with string:
		// if (varValue.m_dwType==DBVT_STRING)
		// {
		//  strcpy(str1,varValue.m_pstring->GetBuffer(StrMaxLen));
		//	varValue.m_pstring->ReleaseBuffer();
		//	*pCtxt << _TEXT(str1);
		// }
					
		//Must be long
		if (varValue.m_dwType!=DBVT_LONG)
		{
			*pCtxt << _T("<B>Internal Error:</B> Unknown type of 'ID_USER' in database [E050]!<BR>\n");
			*pCtxt << _T("</HTML>\n");
					
			fQuery.Close();
			db.Close();

			return;
		}
				
		id_user=varValue.m_lVal;

		//ACTIVE
		varValue.Clear();
		fQuery.GetFieldValue((short) 1, varValue);
			
		//Must be bool				
		if (varValue.m_dwType!=DBVT_BOOL)
		{
			*pCtxt << _T("<B>Internal Error:</B> Unknown type of 'ACTIVE' in database [E060]!<BR>\n");
			*pCtxt << _T("</HTML>\n");
					
			fQuery.Close();
			db.Close();

			return;
		}
		
		bool active;
		if ((varValue.m_boolVal&1)==0) active=false;
		else active=true;
		
		if (!active)
		{
			strcpy(str1a, "<CENTER>\n");
			strcat(str1a, " <TT><FONT SIZE=+2>\n");
			strcat(str1a, " Your account is <B>NOT ACTIVE</B>!<BR>\n");
			strcat(str1a, " </FONT></TT>\n");
			strcat(str1a, "</CENTER>\n");

			prt_warning(pCtxt, AppDir, "run", str1a);

			fQuery.Close();
			db.Close();

			return;
		}
		
		fQuery.Close();
		db.Close();
	}
	catch (CDBException *pEx)
	{
		*pCtxt << _T("<B>Internal Error:</B> Error while working with database 'users' [E070]!<BR>\n");
		
		if (pEx->GetErrorMessage(szError, sizeof(szError)))
		{
			*pCtxt << _T("(") << szError << _T("!)<BR>\n");
		}

		*pCtxt << _T("</HTML>\n");
		return;
	}

	//Connecting to database 'Jobs' through ODBC
	// (Parameter #2 in configuration = 
	//  Registration name of this database in ODBC)!
	strcpy(str1, "DSN=");
	strcat(str1, fggcfg->Get(2));

	try
	{
		//Open database
		if (!db.OpenEx(_TEXT(str1), CDatabase::noOdbcDialog))
		{
			*pCtxt << _T("<B>Internal Error:</B> Can't connect to database 'jobs' [E080]!<BR>\n");
			*pCtxt << _T("</HTML>\n");
					
			return;
		}

		strcpy(str1, "SELECT MAX (Run.ID_RUN) FROM Run");

		if (!fQuery.Open(AFX_DB_USE_DEFAULT_TYPE, _TEXT(str1)))
		{
			*pCtxt << _T("<B>Internal Error:</B> Can't open record set of database 'jobs' [E090]!<BR>\n");
			*pCtxt << _T("</HTML>\n");
					
			db.Close();

			return;
		}

		//Getting last ID_RUN

		id_run=0;
		
		if (!fQuery.IsEOF())
		{
			fQuery.GetFieldValue((short) 0, varValue);

			if (varValue.m_dwType!=DBVT_LONG)
			{
				*pCtxt << _T("<B>Internal Error:</B> Unknown type of 'ID_RUN' in database [E100]!<BR>\n");
				*pCtxt << _T("</HTML>\n");
					
				fQuery.Close();
				db.Close();

				return;
			}
				
			id_run=varValue.m_lVal;

/*			
			do
			{
				fQuery.GetFieldValue((short) 0, varValue);

				if (varValue.m_dwType!=DBVT_LONG)
				{
					*pCtxt << _T("<B>Internal Error:</B> Unknown type of 'ID_RUN' in database!<BR>\n");
					*pCtxt << _T("</HTML>\n");
					
					fQuery.Close();
					db.Close();

					return;
				}
				id_run=varValue.m_lVal;
								
				fQuery.MoveNext();
			}
			while (!fQuery.IsEOF());
*/
		}

		id_run++;
		fQuery.Close();

		//Preparing for inserting into table
		strcpy(str1, "INSERT INTO Run (ID_RUN, ID_USER, FULLNAME, MPI, PROCESSORS, DATE_TIME_RECEIVED) VALUES (");
			ultoa(id_run, str1a, 10);
		strcat(str1, str1a);
		strcat(str1, ", ");
			ultoa(id_user, str1a, 10);
		strcat(str1, str1a);
		strcat(str1, ", '");
		strcat(str1, pstrFullName);
		strcat(str1,"', ");
		strcat(str1, pstrMPI);
		strcat(str1, ", ");
			ultoa(processors, str1a, 10);
		strcat(str1, str1a);
		strcat(str1, ", '");
			_strdate(str1a);
		strcat(str1, str1a);
		strcat(str1," ");
			_strtime(str1a);
		strcat(str1, str1a);
		strcat(str1, "') ");

		db.ExecuteSQL(_TEXT(str1));
		
		//Checking, that job was set to queue
		strcpy(str1, "SELECT Run.ID_RUN FROM Run WHERE ((Run.ID_RUN)=");
			ultoa(id_run,str1a,10);
		strcat(str1, str1a);
		strcat(str1,")");

		if (!fQuery.Open(AFX_DB_USE_DEFAULT_TYPE, _TEXT(str1)))
		{
			*pCtxt << _T("<B>Internal Error:</B> Can't open record set of database 'jobs' [E110]!<BR>\n");
			*pCtxt << _T("</HTML>\n");
					
			db.Close();

			return;
		}

		if (fQuery.IsEOF())
		{

			*pCtxt << _T("<B>Internal Error:</B> Can't insert 'run' job into database [E120]!<BR>\n");
			*pCtxt << _T("</HTML>\n");
					
			fQuery.Close();
			db.Close();

			return;
		}
				
		db.Close();
	}
	catch (CDBException *pEx)
	{
		*pCtxt << _T("<B>Internal Error:</B> Error while working with database 'jobs' [E130]!<BR>\n");
		
		if (pEx->GetErrorMessage(szError, sizeof(szError)))
		{
			*pCtxt << _T("(") << szError << _T("!)<BR>\n");
		}

		*pCtxt << _T("</HTML>\n");
		return;
	}

	//Success!
	strcpy(str1a, "<CENTER>\n");
	strcat(str1a, "Your <B>'run' job</B> was successfully placed into queue with ID=<B>");
		ultoa(id_run, str1b, 10);
	strcat(str1a, str1b);
	strcat(str1a, "</B>!\n");
	strcat(str1a, "</CENTER>\n");

	//Write ID in COMMENTS for SCS Client !!!
	strcat(str1a, "<!--\n");
	strcat(str1a, "SCS_C_ID_RUN=");		
		ultoa(id_run, str1b, 10);
	strcat(str1a, str1b);
	strcat(str1a, "\n-->\n");
	
	prt_warning(pCtxt, AppDir, "run", str1a);

	//fggcfg->Save(); //Saving configuration, if necessary!
}

// Do not edit the following lines, which are needed by ClassWizard.
#if 0
BEGIN_MESSAGE_MAP(CRunExtension, CHttpServer)
	//{{AFX_MSG_MAP(CRunExtension)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()
#endif	// 0



///////////////////////////////////////////////////////////////////////
// If your extension will not use MFC, you'll need this code to make
// sure the extension objects can find the resource handle for the
// module.  If you convert your extension to not be dependent on MFC,
// remove the comments arounn the following AfxGetResourceHandle()
// and DllMain() functions, as well as the g_hInstance global.

/****

static HINSTANCE g_hInstance;

HINSTANCE AFXISAPI AfxGetResourceHandle()
{
	return g_hInstance;
}

BOOL WINAPI DllMain(HINSTANCE hInst, ULONG ulReason,
					LPVOID lpReserved)
{
	if (ulReason == DLL_PROCESS_ATTACH)
	{
		g_hInstance = hInst;
	}

	return TRUE;
}

****/
