#ifndef _MPISERVE_H_
#define _MPISERVE_H_

//
//  Values are 32 bit values layed out as follows:
//
//   3 3 2 2 2 2 2 2 2 2 2 2 1 1 1 1 1 1 1 1 1 1
//   1 0 9 8 7 6 5 4 3 2 1 0 9 8 7 6 5 4 3 2 1 0 9 8 7 6 5 4 3 2 1 0
//  +---+-+-+-----------------------+-------------------------------+
//  |Sev|C|R|     Facility          |               Code            |
//  +---+-+-+-----------------------+-------------------------------+
//
//  where
//
//      Sev - is the severity code
//
//          00 - Success
//          01 - Informational
//          10 - Warning
//          11 - Error
//
//      C - is the Customer code flag
//
//      R - is a reserved bit
//
//      Facility - is the facility code
//
//      Code - is the facility's status code
//
//
// Define the facility codes
//


//
// Define the severity codes
//
#define STATUS_SEVERITY_WARNING          0x2
#define STATUS_SEVERITY_SUCCESS          0x0
#define STATUS_SEVERITY_INFORMATIONAL    0x1
#define STATUS_SEVERITY_ERROR            0x3


//
// MessageId: MPISERVER_SUCCESS
//
// MessageText:
//
//  MPI Success:
//
#define MPISERVER_SUCCESS                0x000003E8L

//
// MessageId: MPISERVER_INFORMATIONAL
//
// MessageText:
//
//  MPI Informational:
//
#define MPISERVER_INFORMATIONAL          0x000007D0L

//
// MessageId: MPISERVER_WARNING
//
// MessageText:
//
//  MPI Warning:
//
#define MPISERVER_WARNING                0x80000BB8L

//
// MessageId: MPISERVER_ERROR
//
// MessageText:
//
//  MPI Error:
//
#define MPISERVER_ERROR                  0xC0000FA0L

#define MPISERVEJOBIDLEN	256

typedef struct _QueueNode
{
	struct _QueueNode *pNext;
	char szJobID[MPISERVEJOBIDLEN];
	HANDLE hProcs[MAX_NUM_SHMEM_PROCS];
} JOBQUEUE;

LONG CreateRegistryInfo(int argc,char **argv);
LONG DeleteRegistryInfo();
LONG GetPortNumber(WORD *wPortNumber);
DWORD WINAPI SocketSetupAndListen(LPVOID lpV);
DWORD WINAPI MPIServeQueryInfo(LPVOID lpV);
DWORD WINAPI MPIServeCreateSingleProcess(LPVOID lpV);
DWORD WINAPI MPIServeKillSingleProcess(LPVOID lpV);
DWORD WINAPI MPIServeStartMPIJob(LPVOID lpV);
DWORD WINAPI MPIServeKillMPIJob(LPVOID lpV);

#endif
