#include "windows.h"
#include "packets.h"
#include "processinfo.h"
#include "infoprint.h"
#include "crtdbg.h"

BOOL ReadConfigFile(char *szConfigFile,JOBINFO *JobInfo)
{
	FILE *pInputFile = NULL;
	BOOL fStatus = FALSE;
	BOOL fFound = FALSE;
	char szMachine[256];
	char szExecutable[256];
	int nNumFields;
	DWORD dwGlobalRank=0;
	int i;

	_ASSERTE(szConfigFile);
	_ASSERTE(JobInfo);

	pInputFile = fopen(szConfigFile,"r");
	_ASSERTE(pInputFile);
	if (NULL == pInputFile)
		goto cleanup;
	while (!feof(pInputFile))
	{
		fFound = FALSE;
		nNumFields = fscanf(pInputFile,"%s %[^\n]s",szMachine,szExecutable);
		if (2 == nNumFields)
		{
			for (i = 0;i < (int)JobInfo->dwNumMachines;i++)
			{
				if (!strcmp(szMachine,JobInfo->Machine[i].szMachineName))
				{
					fFound = TRUE;
					strcpy(JobInfo->Machine[i].Process[JobInfo->Machine[i].dwNumProcesses].szExecutable,
						   szExecutable);
					JobInfo->Machine[i].Process[JobInfo->Machine[i].dwNumProcesses].dwLocalBufferNumber = JobInfo->Machine[i].dwNumProcesses;
					JobInfo->Machine[i].Process[JobInfo->Machine[i].dwNumProcesses].dwMachineNumber = i;
					JobInfo->Machine[i].Process[JobInfo->Machine[i].dwNumProcesses].dwGlobalRank = dwGlobalRank;
					JobInfo->Machine[i].Process[JobInfo->Machine[i].dwNumProcesses].hSharedMemoryBuffer = NULL;
					JobInfo->Machine[i].dwNumProcesses++;
					break;
				}
			}
			if (!fFound)
			{
				strcpy(JobInfo->Machine[JobInfo->dwNumMachines].szMachineName,szMachine);
				strcpy(JobInfo->Machine[JobInfo->dwNumMachines].Process[JobInfo->Machine[JobInfo->dwNumMachines].dwNumProcesses].szExecutable,
					   szExecutable);
				JobInfo->Machine[JobInfo->dwNumMachines].Process[JobInfo->Machine[JobInfo->dwNumMachines].dwNumProcesses].dwLocalBufferNumber = JobInfo->Machine[JobInfo->dwNumMachines].dwNumProcesses;
				JobInfo->Machine[JobInfo->dwNumMachines].Process[JobInfo->Machine[JobInfo->dwNumMachines].dwNumProcesses].dwMachineNumber = JobInfo->dwNumMachines;
				JobInfo->Machine[JobInfo->dwNumMachines].Process[JobInfo->Machine[JobInfo->dwNumMachines].dwNumProcesses].dwGlobalRank = dwGlobalRank;
				JobInfo->Machine[JobInfo->dwNumMachines].Process[JobInfo->Machine[JobInfo->dwNumMachines].dwNumProcesses].hSharedMemoryBuffer = NULL;
				JobInfo->Machine[JobInfo->dwNumMachines].dwNumProcesses++;
				JobInfo->dwNumMachines++;
			}
			JobInfo->dwWorldSize++;
			dwGlobalRank++;
		}
		else
			break;
	}
	fStatus = TRUE;
	if (1 == JobInfo->dwNumMachines)
		JobInfo->dwMyMachineID = 0;
cleanup:
	if (pInputFile)
		fclose(pInputFile);
	return fStatus;
}