#include <windows.h>
#include <stdio.h>
#include <stdlib.h>
#include <process.h>
#include <tchar.h>
#include <winsock.h>
#include "service.h"

DWORD MPIServeCreateProcess(MPIServePacket_T CommandPacket)
{
	STARTUPINFO siInfo;
	PROCESS_INFORMATION piInfo;
	BOOL bProcessCreate=FALSE;
	TCHAR szMsg[256];
	DWORD dwStatus = ERROR_SUCCESS;

	memset(&siInfo,0,sizeof(STARTUPINFO));
	memset(&piInfo,0,sizeof(PROCESS_INFORMATION));
	bProcessCreate = CreateProcess(
							NULL,
							CommandPacket.uInfo.Buffer,
							NULL,		// default process security
							NULL,		// default thread security
							TRUE,		// Inherit handles
							DETACHED_PROCESS,
							NULL,		// inherit environment
							NULL,		// same initial direcotry as this process (may change later)
							&siInfo,	// startup info
							&piInfo);	// process info
	if (bProcessCreate)
	{
		_stprintf(szMsg,TEXT("Successfully started process: %s"),CommandPacket.uInfo.Buffer);
		ReportInfoToMessageLog(szMsg);
	}
	else
	{
		TCHAR szErrMsg[256];
		dwStatus = GetLastError();
		GetLastErrorText(szErrMsg,256);
		_stprintf(szMsg,TEXT("Error starting process: %s -- %s"),CommandPacket.uInfo.Buffer,szErrMsg);
		AddToMessageLog(szMsg);
	}
	return dwStatus;
}
